

/*
DHT22->2
CLK->3
DAT->4
RST->5
A0 - Saved
A1 - Next
A2 - (+)
A3 - (-)


6 - Relay 1
*/


#include <DHT.h>


#include <virtuabotixRTC.h> //Library used
#include <LiquidCrystal_I2C.h>
#include <EEPROM.h>



LiquidCrystal_I2C lcd(0x27,16,2);  // set the LCD address to 0x27 for a 20 chars and 4 line display


//Wiring SCLK -> 2, I/O -> 3, CE -> 4
//Or CLK -> 3 , DAT -> 4, Reset -> 5


virtuabotixRTC myRTC(3, 4, 5); //If you change the wiring change the pins here also


const int SetSW = A0;
const int NextSw = A1;
const int UpSw = A2;
const int DownSw = A3;



const int buzzer = A8;



int buttonState1;             // the current reading from the input pin
int lastButtonState1 = LOW;   // the previous reading from the input pin
int buttonState2;             // the current reading from the input pin
int lastButtonState2 = LOW;   // the previous reading from the input pin


//int ledState = HIGH;         // the current state of the output pin
int buttonState3;             // the current reading from the input pin
int lastButtonState3 = LOW;   // the previous reading from the input pin
int buttonState4;             // the current reading from the input pin
int lastButtonState4= LOW;   // the previous reading from the input pin


// the following variables are unsigned longs because the time, measured in
// milliseconds, will quickly become a bigger number than can be stored in an int.
unsigned long lastDebounceTime1 = 0;  // the last time the output pin was toggled
unsigned long debounceDelay1 = 50;    // the debounce time; increase if the output flickers
unsigned long lastDebounceTime2 = 0;  // the last time the output pin was toggled
unsigned long debounceDelay2 = 50;    // the debounce time; increase if the output flickers
unsigned long lastDebounceTime3 = 0;  // the last time the output pin was toggled
unsigned long debounceDelay3 = 50;    // the debounce time; increase if the output flickers
unsigned long lastDebounceTime4 = 0;  // the last time the output pin was toggled
unsigned long debounceDelay4 = 50;   


bool start = false;
bool   set = false; 
/* Memory storage */
int addr1 = 0;
int addr2 = 2;
int addr3 = 4;
int addr4 = 6;
int addr5 = 8;
int addr6 = 10;


#define DHTPIN 2     // what pin we're connected to
#define DHTTYPE DHT22   // DHT 22  (AM2302)
#define Liquid_Detection_Pin 7     //Output pin on sensor




DHT dht(DHTPIN, DHTTYPE); //// Initialize DHT sensor for normal 16mhz Arduino


const int relay1 = 6;



//Variables
int chk;
float hum;  //Stores humidity value
float temp; //Stores temperature value


bool debug =false;
bool debug1 = false;


bool schedule_start = false;
bool week_set = false;
bool day_set = false;
bool hour_set = false;
bool min_set = false;
bool sec_set = false;
bool countdown_start = false;


int i;
int n1,n2,n3,n4,n5;
extern volatile unsigned long timer0_millis;





void setup() {
  // put your setup code here, to run once:
    Serial.begin(9600);
    lcd.init();                      // initialize the lcd 
    lcd.backlight();
    lcd.setCursor(0, 0);
    lcd.print("LCD OK");
    lcd.clear();    
    delay(2000);
    dht.begin();
    lcd.print("TEMP SENSOR OK");
    lcd.clear();    
    delay(2000);
    pinMode(SetSW, INPUT_PULLUP);    
    pinMode(NextSw, INPUT_PULLUP);    
    pinMode(UpSw, INPUT_PULLUP);    
    pinMode(DownSw, INPUT_PULLUP);   
    pinMode(relay1, OUTPUT);
    pinMode(buzzer, OUTPUT);
    digitalWrite(relay1,LOW);
        digitalWrite(buzzer,HIGH);      
        delay(100);
        digitalWrite(buzzer,LOW);      
  // Set the current date, and time in the following format:
 // seconds, minutes, hours, day of the week, day of the month, month, year
//myRTC.setDS1302Time(00, 30, 11, 07, 02, 03, 2024); //Here you write your actual time/date as shown above 
 //but remember to "comment/remove" this function once you're done
 //The setup is done only one time and the module will continue counting it automatically


   n1 = EEPROM.read(addr1);
   n2 = EEPROM.read(addr2);
   n3 = EEPROM.read(addr3);
   n4 = EEPROM.read(addr4);



    if(n1>24)n1=0;
    else if(n1<0)n1=0;


    if(n2>60)n2=0;
    else if(n2<0)n2=0;


    if(n3>60)n3=0;
    else if(n3<0)n3=0;
    
    if(n4>7)n4=0;
    else if(n4<0)n4=0;   


    lcd.clear(); 
    delay(2000);
    lcd.setCursor(0, 0);
    lcd.print("Please Set Time");
    lcd.setCursor(0, 1);
    lcd.print("Saved");
    lcd.print(" Set");
    lcd.print(" (+)");
    lcd.print("(-)");


  
}


void loop() {
  // put your main code here, to run repeatedly:
    hum = dht.readHumidity();
    temp= dht.readTemperature();
    //Print temp and humidity values to serial monitor
    if(debug){
      Serial.print("Humidity: ");
      Serial.print(hum);
      Serial.print(" %, Temp: ");
      Serial.print(temp);
      Serial.println(" Celsius");
    }


    myRTC.updateTime();


    if(start & !schedule_start){
        lcd.setCursor(0, 0);
        lcd.print("H:");
        lcd.print(hum);
        lcd.print(" T:");
        lcd.print(temp);
/*
        lcd.print("NowTime:");
        //lcd.setCursor(5, 0);
        lcd.print(myRTC.hours);
        //lcd.setCursor(7, 0);
        lcd.print(":");         
        //lcd.setCursor(8, 0);  
        lcd.print(myRTC.minutes);    
        //lcd.setCursor(10, 0);      
        lcd.print(":");    
        //lcd.setCursor(11, 0);     
        lcd.print(myRTC.seconds);
*/
 
        
        lcd.setCursor(0, 1);           
        lcd.print("SetTime:");
        //lcd.setCursor(9, 1);
        lcd.print(n1);
        //lcd.setCursor(11, 1);
        lcd.print(":");
        //lcd.setCursor(12, 1);
        lcd.print(n2);
        //lcd.setCursor(14, 1);
        lcd.print(":");
        //lcd.setCursor(15, 1);
        lcd.print(n3);
  
      
            if (digitalRead(Liquid_Detection_Pin)) {
            //Serial.println("Liquid Detected!");
            digitalWrite(buzzer,LOW); 
          }
          else {
            //Serial.println("No Liquid!");
            digitalWrite(buzzer,HIGH);   
          }      
    }else if(start & schedule_start){ // Set Schedule Starts
 
      Serial.println("Schedule Starts");
      int Seconds = ( millis()/1000 );
      int Minutes = ( millis()/1000 ) / 60;
      int Hours = ( ( millis()/1000 ) / 60 ) / 60;


      if(!countdown_start){
        countdown_start = true;
        timer0_millis=0;
        digitalWrite(relay1,HIGH);   
      }


      if(debug1){
        Serial.print("Hrs:");
        Serial.print(Hours);
        Serial.print(":Min:");
        Serial.print(Minutes);
        Serial.print(":Sec:");
        Serial.print(Seconds);
        Serial.print(":Countdown:");
        Serial.println(840 - Seconds);
      }
        if(Seconds >840){
           
            timer0_millis=0;
            countdown_start = false;
            schedule_start = false;
            if(debug1)Serial.println("END");
            day_set = false;
            hour_set = false;
            min_set = false;
            sec_set = false;
            digitalWrite(relay1,LOW);   
        }


      /*Adds Countdown Timer*/
      lcd.setCursor(0, 0);
      lcd.print("CountDown:");
      lcd.setCursor(0, 1);     
      lcd.print(840 - Seconds);
      delay(500);
      //timer0_millis=0;
    }
/*
      int Seconds = ( millis()/1000 );
      int Minutes = ( millis()/1000 ) / 60;
      int Hours = ( ( millis()/1000 ) / 60 ) / 60;


      if(!countdown_start){
        countdown_start = true;
        timer0_millis=0;
      }


      if(debug1){
        Serial.print("Hrs:");
        Serial.print(Hours);
        Serial.print(":Min:");
        Serial.print(Minutes);
        Serial.print(":Sec:");
        Serial.print(Seconds);
        Serial.print(":Countdown:");
        Serial.println(840 - Seconds);
        if(Seconds >840){
           
            timer0_millis=0;
            countdown_start = false;
        }
      }
*/
   
    if(debug){
       Serial.print("Current Date / Time: ");
       Serial.print(myRTC.month);
       Serial.print("/");
       Serial.print(myRTC.dayofmonth); //You can switch between day and month if you're using American system
       Serial.print("/");
       Serial.print(myRTC.year);
       Serial.print(" ");
       Serial.print(myRTC.hours);
       Serial.print(":");
       Serial.print(myRTC.minutes);
       Serial.print(":");
       Serial.print(myRTC.seconds);
       Serial.print("Day of Week:");
       Serial.println(myRTC.dayofweek);
       delay(1000);
    }





  if(day_set & hour_set & min_set & sec_set){
    schedule_start = true;
    lcd.clear();
  }




/* n1 = hour, n2 = min, n3 = sec , n4 = day*/
if(start){
  if(myRTC.dayofweek == n4 & !day_set){
    day_set = true;
    Serial.println("Day Set");
  }
  if(myRTC.hours == n1 & !hour_set){
    hour_set = true;
    Serial.println("Hour Set");
  }
  if(myRTC.minutes == n2 & !min_set){
    min_set = true;
    Serial.println("Min Set");
  }
  if(myRTC.seconds == 0 & !sec_set){
    sec_set = true;
    Serial.println("Sec Set");
  }
}



  int reading1 = digitalRead(SetSW);
  int reading2 = digitalRead(NextSw);
  int reading3 = digitalRead(UpSw);
  int reading4 = digitalRead(DownSw); 


  if (reading1 != lastButtonState1) {
    lastDebounceTime1 = millis();


  }


/*SAVED Button*/


  if ((millis() - lastDebounceTime1) > debounceDelay1) {
    if (reading1 != buttonState1) {
      buttonState1 = reading1;


        if (buttonState1 == LOW) {
            start = true;
            //set = false; 
            i=0; 


            Serial.println("SAVED");
            lcd.setCursor(0, 0);
            EEPROM.write(addr1, n1);
            EEPROM.write(addr2, n2);
            EEPROM.write(addr3, n3);
            EEPROM.write(addr4, n4);
            lcd.print("DATA SET");
            lcd.clear();
           
            delay(2000);
        }
    }
  }


/*NEXT Button*/
  if (reading2 != lastButtonState2) {
    lastDebounceTime2 = millis();


  }


    if ((millis() - lastDebounceTime2) > debounceDelay2) {
    if (reading2 != buttonState2) {
      buttonState2 = reading2;


      if (buttonState2 == LOW) {
        i++;
         if(5< i){
          i=0;
         }
        Serial.print("i:");
        Serial.println(i);
        start = false;
        //set = true; 
        
        digitalWrite(relay1,LOW);



        if(i ==1 ){
    
            lcd.clear();
            delay(500);
            lcd.setCursor(0,0);
            lcd.print("Set Hour:");
    //        lcd.setCursor(0,1);
    //        lcd.print("  ");
    //        lcd.setCursor(0,1);
            lcd.print(n1);


        }else if(i ==2){
            lcd.clear();
            delay(500);
            lcd.setCursor(0,0);
            lcd.print("Set Min:");
    //        lcd.setCursor(0,1);
    //       lcd.print("  ");
    //        lcd.setCursor(0,1);
            lcd.print(n2);


        }else if(i ==3){
            lcd.clear();
            delay(500);
            lcd.setCursor(0,0);
            lcd.print("Set Sec:");
    //        lcd.setCursor(0,1);
    //        lcd.print("  ");
    //        lcd.setCursor(0,1);
            lcd.print(n3);


        }else if(i ==4){
            lcd.clear();
            delay(500);
            lcd.setCursor(0,0);
            lcd.print("Set Day:");
    //        lcd.setCursor(0,1);
    //        lcd.print("  ");
    //        lcd.setCursor(0,1);
            lcd.print(n4);


        }else if(i ==5){
            lcd.clear();
            delay(500);
            lcd.setCursor(0,0);
            lcd.print("Set U-Temp:");
    //        lcd.setCursor(0,1);
    //        lcd.print("  ");
    //        lcd.setCursor(0,1);
            lcd.print(n5);


        }
        


      }
    }
  }


  /*(+) Button*/
  if (reading3 != lastButtonState3) {
    // reset the debouncing timer
    lastDebounceTime3 = millis();


  }


  if ((millis() - lastDebounceTime3) > debounceDelay3) {
    if (reading3 != buttonState3) {
      buttonState3 = reading3;


      if (buttonState3 == LOW) {
      if(i ==1 ){    
          if(n1>24)n1=0; //Hours
          else n1++;
          lcd.setCursor(0,1);
          lcd.print("  ");
          lcd.setCursor(0,1);
          lcd.print(n1);
        }else if(i ==2){
          if(n2>59)n2=0; //minutes
          else n2++;
          lcd.setCursor(0,1); 
          lcd.print("  ");
          lcd.setCursor(0,1);
          lcd.print(n2);  
        }else if(i ==3){
          if(n3>59)n3=0; //Seconds
          else n3++;;
          lcd.setCursor(0,1); 
          lcd.print("  ");
          lcd.setCursor(0,1);
          lcd.print(n3);    
        }else if(i ==4){
          if(n4>7)n4=0; //Day
          else n4++;;
          lcd.setCursor(0,1); 
          lcd.print("  ");
          lcd.setCursor(0,1);
          lcd.print(n4);    
        }else if(i ==5){
          if(n5>50)n5=0; //Temp
          else n5++;;
          lcd.setCursor(0,1); 
          lcd.print("  ");
          lcd.setCursor(0,1);
          lcd.print(n5);    
        }
  
      }
    }
  }


  /*(-) Button*/


  if (reading4 != lastButtonState4) {
    // reset the debouncing timer
    lastDebounceTime4 = millis();


  }


  if ((millis() - lastDebounceTime4) > debounceDelay4) {
    if (reading4 != buttonState4) {
      buttonState4 = reading4;


        if (buttonState4 == LOW) {
      
              if(i ==1 ){ 
                n1--;
                if(n1<0) n1=24;
                lcd.setCursor(0,1);
                lcd.print(n1);
              }else if(i ==2){     
                n2--;
                if(n2<0) n2=59;          
                lcd.setCursor(0,1); 
                lcd.print(n2);  
              }else if(i ==3){
                n3--;
                if(n3<0) n3=59;     
                lcd.setCursor(0,1); 
                lcd.print(n3);    
              }else if(i ==4){
                n4--;
                if(n4<0) n4=7;     
                lcd.setCursor(0,1); 
                lcd.print(n4);    
              }else if(i ==5){
                n5--;
                if(n5<0) n5=50;     
                lcd.setCursor(0,1); 
                lcd.print(n5);    
              }


        }           


      }
    }



  lastButtonState1 = reading1;
  lastButtonState2 = reading2;
  lastButtonState3 = reading3;
  lastButtonState4 = reading4;
      
  delay(250);
}

